<center><a href="ex3.c">Actual source code: ex3.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:20:48+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80">
<a name="line2">  2: </a>static char help[] = <font color="#666666">"Tests parallel vector assembly.  Input arguments are\n\</font>
<a name="line3">  3: </a><font color="#666666">  -n &lt;length&gt; : local vector length\n\n"</font>;

<a name="line5"> 5: </a> #include <A href="../../../../../include/petscvec.h.html">petscvec.h</A>
<a name="line6"> 6: </a> #include <A href="../../../../../include/petscsys.h.html">petscsys.h</A>

<a name="line10"> 10: </a><strong><font color="#4169E1"><a name="main"></a>int main(int argc,char **argv)</font></strong>
<a name="line11"> 11: </a>{
<a name="line12"> 12: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMPIInt.html#PetscMPIInt">PetscMPIInt</A>    <A href="../../../../../docs/manualpages/Sys/size.html#size">size</A>,<A href="../../../../../docs/manualpages/Sys/rank.html#rank">rank</A>;
<a name="line14"> 14: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       n = 5,idx;
<a name="line15"> 15: </a>  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    one = 1.0,two = 2.0,three = 3.0;
<a name="line16"> 16: </a>  <A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>            x,y;

<a name="line18"> 18: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInitialize.html#PetscInitialize">PetscInitialize</A>(&amp;argc,&amp;argv,(char*)0,help);
<a name="line19"> 19: </a>  <A href="../../../../../docs/manualpages/Sys/PetscOptionsGetInt.html#PetscOptionsGetInt">PetscOptionsGetInt</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-n"</font>,&amp;n,<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line20"> 20: </a>  <font color="#4169E1">if</font> (n &lt; 5) n = 5;
<a name="line21"> 21: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_size.html#MPI_Comm_size">MPI_Comm_size</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;<A href="../../../../../docs/manualpages/Sys/size.html#size">size</A>);
<a name="line22"> 22: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_rank.html#MPI_Comm_rank">MPI_Comm_rank</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;<A href="../../../../../docs/manualpages/Sys/rank.html#rank">rank</A>);

<a name="line24"> 24: </a>  <font color="#4169E1">if</font> (<A href="../../../../../docs/manualpages/Sys/size.html#size">size</A> &lt; 2) <A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(1,<font color="#666666">"Must be run with at least two processors"</font>);

<a name="line26"> 26: </a>  <font color="#B22222">/* create two vector */</font>
<a name="line27"> 27: </a>  <A href="../../../../../docs/manualpages/Vec/VecCreateSeq.html#VecCreateSeq">VecCreateSeq</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,n,&amp;x);
<a name="line28"> 28: </a>  <A href="../../../../../docs/manualpages/Vec/VecCreate.html#VecCreate">VecCreate</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;y);
<a name="line29"> 29: </a>  <A href="../../../../../docs/manualpages/Vec/VecSetSizes.html#VecSetSizes">VecSetSizes</A>(y,n,<A href="../../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>);
<a name="line30"> 30: </a>  <A href="../../../../../docs/manualpages/Vec/VecSetFromOptions.html#VecSetFromOptions">VecSetFromOptions</A>(y);
<a name="line31"> 31: </a>  <A href="../../../../../docs/manualpages/Vec/VecSet.html#VecSet">VecSet</A>(x,one);
<a name="line32"> 32: </a>  <A href="../../../../../docs/manualpages/Vec/VecSet.html#VecSet">VecSet</A>(y,two);

<a name="line34"> 34: </a>  <font color="#4169E1">if</font> (<A href="../../../../../docs/manualpages/Sys/rank.html#rank">rank</A> == 1) {
<a name="line35"> 35: </a>    idx = 2; <A href="../../../../../docs/manualpages/Vec/VecSetValues.html#VecSetValues">VecSetValues</A>(y,1,&amp;idx,&amp;three,<A href="../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);
<a name="line36"> 36: </a>    idx = 0; <A href="../../../../../docs/manualpages/Vec/VecSetValues.html#VecSetValues">VecSetValues</A>(y,1,&amp;idx,&amp;two,<A href="../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);
<a name="line37"> 37: </a>    idx = 0; <A href="../../../../../docs/manualpages/Vec/VecSetValues.html#VecSetValues">VecSetValues</A>(y,1,&amp;idx,&amp;one,<A href="../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);
<a name="line38"> 38: </a>  }
<a name="line39"> 39: </a>  <font color="#4169E1">else</font> {
<a name="line40"> 40: </a>    idx = 7; <A href="../../../../../docs/manualpages/Vec/VecSetValues.html#VecSetValues">VecSetValues</A>(y,1,&amp;idx,&amp;three,<A href="../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);
<a name="line41"> 41: </a>  }
<a name="line42"> 42: </a>  <A href="../../../../../docs/manualpages/Vec/VecAssemblyBegin.html#VecAssemblyBegin">VecAssemblyBegin</A>(y);
<a name="line43"> 43: </a>  <A href="../../../../../docs/manualpages/Vec/VecAssemblyEnd.html#VecAssemblyEnd">VecAssemblyEnd</A>(y);

<a name="line45"> 45: </a>  <A href="../../../../../docs/manualpages/Vec/VecView.html#VecView">VecView</A>(y,<A href="../../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_WORLD.html#PETSC_VIEWER_STDOUT_WORLD">PETSC_VIEWER_STDOUT_WORLD</A>);

<a name="line47"> 47: </a>  <A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(x);
<a name="line48"> 48: </a>  <A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(y);

<a name="line50"> 50: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFinalize.html#PetscFinalize">PetscFinalize</A>();
<a name="line51"> 51: </a>  <font color="#4169E1">return</font> 0;
<a name="line52"> 52: </a>}
<a name="line53"> 53: </a>
</pre>
</body>

</html>
